diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-content/plugins/wp-super-cache/wp-cache.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/wp-super-cache/wp-cache.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-content/plugins/wp-super-cache/wp-cache.php	2012-10-29 12:35:33.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-content/plugins/wp-super-cache/wp-cache.php	2012-12-17 16:18:44.000000000 -0600
***************
*** 3,9 ****
  Plugin Name: WP Super Cache
  Plugin URI: http://ocaoimh.ie/wp-super-cache/
  Description: Very fast caching plugin for WordPress.
! Version: 1.1
  Author: Donncha O Caoimh
  Author URI: http://ocaoimh.ie/
  */
--- 3,9 ----
  Plugin Name: WP Super Cache
  Plugin URI: http://ocaoimh.ie/wp-super-cache/
  Description: Very fast caching plugin for WordPress.
! Version: 1.2
  Author: Donncha O Caoimh
  Author URI: http://ocaoimh.ie/
  */
***************
*** 115,123 ****
  	@unlink( $cache_path . 'meta' );
  	@unlink( $cache_path . 'supercache' );
  	wp_clear_scheduled_hook( 'wp_cache_check_site_hook' );
  	wp_cache_disable_plugin();
  }
! register_deactivation_hook( __FILE__, 'wpsupercache_deactivate' );
  
  function wpsupercache_activate() {
  }
--- 115,125 ----
  	@unlink( $cache_path . 'meta' );
  	@unlink( $cache_path . 'supercache' );
  	wp_clear_scheduled_hook( 'wp_cache_check_site_hook' );
+ 	wp_clear_scheduled_hook( 'wp_cache_gc' );
+ 	wp_clear_scheduled_hook( 'wp_cache_gc_watcher' );
  	wp_cache_disable_plugin();
  }
! register_uninstall_hook( __FILE__, 'wpsupercache_deactivate' );
  
  function wpsupercache_activate() {
  }
***************
*** 154,159 ****
--- 156,162 ----
  
  function wp_cache_manager_error_checks() {
  	global $wpmu_version, $wp_cache_debug, $wp_cache_cron_check, $cache_enabled, $super_cache_enabled, $wp_cache_config_file, $wp_cache_mobile_browsers, $wp_cache_mobile_prefixes, $wp_cache_mobile_browsers, $wp_cache_mobile_enabled, $wp_cache_mod_rewrite, $cache_path;
+ 	global $dismiss_htaccess_warning, $dismiss_readable_warning, $dismiss_gc_warning, $wp_cache_shutdown_gc;
  
  	if ( !wpsupercache_site_admin() )
  		return false;
***************
*** 205,211 ****
  					<p><?php printf( __( 'Please see entry 16 in the <a href="%s">Troubleshooting section</a> of the readme.txt', 'wp-super-cache' ), 'http://wordpress.org/extend/plugins/wp-super-cache/faq/' ); ?></p>
  					</div>
  					<?php
- 					return true;
  				} else {
  					wp_cache_replace_line('^ *\$wp_cache_cron_check', "\$wp_cache_cron_check = 1;", $wp_cache_config_file);
  				}
--- 208,213 ----
***************
*** 248,267 ****
  		define( "SUBMITDISABLED", ' ' );
  	}
  
  	// Server could be running as the owner of the wp-content directory.  Therefore, if it's
  	// writable, issue a warning only if the permissions aren't 755.
! 	if( is_writeable_ACLSafe( WP_CONTENT_DIR . '/' ) ) {
  		$wp_content_stat = stat(WP_CONTENT_DIR . '/');
  		$wp_content_mode = decoct( $wp_content_stat[ 'mode' ] & 0777 );
  		if( substr( $wp_content_mode, -2 ) == '77' ) {
  			?><div id="message" class="updated fade"><h3><?php printf( __( 'Warning! %s is writeable!', 'wp-super-cache' ), WP_CONTENT_DIR ); ?></h3>
  			<p><?php printf( __( 'You should change the permissions on %s and make it more restrictive. Use your ftp client, or the following command to fix things:', 'wp-super-cache' ), WP_CONTENT_DIR ); ?> <code>chmod 755 <?php echo WP_CONTENT_DIR; ?>/</code></p>
! 			<p><?php _e( '<a href="http://codex.wordpress.org/Changing_File_Permissions">This page</a> explains how to change file permissions.', 'wp-super-cache' ); ?></p></div>
  			<?php
  		}
  	}
  
! 	if ( function_exists( "is_main_site" ) && true == is_main_site() || function_exists( 'is_main_blog' ) && true == is_main_blog() ) {
  	$home_path = trailingslashit( get_home_path() );
  	$scrules = implode( "\n", extract_from_markers( $home_path.'.htaccess', 'WPSuperCache' ) );
  	if ( $cache_enabled && $wp_cache_mod_rewrite && !$wp_cache_mobile_enabled && strpos( $scrules, addcslashes( implode( '|', $wp_cache_mobile_browsers ), ' ' ) ) ) {
--- 250,310 ----
  		define( "SUBMITDISABLED", ' ' );
  	}
  
+ 	$valid_nonce = isset($_REQUEST['_wpnonce']) ? wp_verify_nonce($_REQUEST['_wpnonce'], 'wp-cache') : false;
+ 	// Check that garbage collection is running
+ 	if ( $valid_nonce && $_POST[ 'action' ] == 'dismiss_gc_warning' ) {
+ 		wp_cache_replace_line('^ *\$dismiss_gc_warning', "\$dismiss_gc_warning = 1;", $wp_cache_config_file);
+ 		$dismiss_gc_warning = 1;
+ 	} elseif ( !isset( $dismiss_gc_warning ) ) {
+ 		$dismiss_gc_warning = 0;
+ 	}
+ 	if ( $cache_enabled && ( !isset( $wp_cache_shutdown_gc ) || $wp_cache_shutdown_gc == 0 ) && function_exists( 'get_gc_flag' ) ) {
+ 		$gc_flag = get_gc_flag();
+ 		if ( $dismiss_gc_warning == 0 ) {
+ 			if ( false == maybe_stop_gc( $gc_flag ) && false == wp_next_scheduled( 'wp_cache_gc' ) ) {
+ 				?><div id="message" class="updated fade"><h3><?php _e( 'Warning! Garbage collection is not scheduled!', 'wp-super-cache' ); ?></h3>
+ 				<p><?php _e( 'Garbage collection by this plugin clears out expired and old cached pages on a regular basis. Use <a href="#expirytime">this form</a> to enable it.', 'wp-super-cache' ); ?> </p>
+ 				<form action="" method="POST">
+ 				<input type="hidden" name="action" value="dismiss_gc_warning" />
+ 				<input type="hidden" name="page" value="wpsupercache" />
+ 				<?php wp_nonce_field( 'wp-cache' ); ?>
+ 				<input type='submit' value='<?php _e( 'Dismiss', 'wp-super-cache' ); ?>' />
+ 				</form>
+ 				<br />
+ 				</div>
+ 				<?php
+ 			}
+ 		}
+ 	}
+ 
  	// Server could be running as the owner of the wp-content directory.  Therefore, if it's
  	// writable, issue a warning only if the permissions aren't 755.
! 	if ( $valid_nonce && $_POST[ 'action' ] == 'dismiss_readable_warning' ) {
! 		wp_cache_replace_line('^ *\$dismiss_readable_warning', "\$dismiss_readable_warning = 1;", $wp_cache_config_file);
! 		$dismiss_readable_warning = 1;
! 	} elseif ( !isset( $dismiss_readable_warning ) ) {
! 		$dismiss_readable_warning = 0;
! 	}
! 	if( $dismiss_readable_warning == 0 && is_writeable_ACLSafe( WP_CONTENT_DIR . '/' ) ) {
  		$wp_content_stat = stat(WP_CONTENT_DIR . '/');
  		$wp_content_mode = decoct( $wp_content_stat[ 'mode' ] & 0777 );
  		if( substr( $wp_content_mode, -2 ) == '77' ) {
  			?><div id="message" class="updated fade"><h3><?php printf( __( 'Warning! %s is writeable!', 'wp-super-cache' ), WP_CONTENT_DIR ); ?></h3>
  			<p><?php printf( __( 'You should change the permissions on %s and make it more restrictive. Use your ftp client, or the following command to fix things:', 'wp-super-cache' ), WP_CONTENT_DIR ); ?> <code>chmod 755 <?php echo WP_CONTENT_DIR; ?>/</code></p>
! 			<p><?php _e( '<a href="http://codex.wordpress.org/Changing_File_Permissions">This page</a> explains how to change file permissions.', 'wp-super-cache' ); ?></p>
! 			<form action="" method="POST">
! 			<input type="hidden" name="action" value="dismiss_readable_warning" />
! 			<input type="hidden" name="page" value="wpsupercache" />
! 			<?php wp_nonce_field( 'wp-cache' ); ?>
! 			<input type='submit' value='<?php _e( 'Dismiss', 'wp-super-cache' ); ?>' />
! 			</form>
! 			<br />
! 			</div>
  			<?php
  		}
  	}
  
! 	if ( function_exists( "is_main_site" ) && true == is_main_site() ) {
  	$home_path = trailingslashit( get_home_path() );
  	$scrules = implode( "\n", extract_from_markers( $home_path.'.htaccess', 'WPSuperCache' ) );
  	if ( $cache_enabled && $wp_cache_mod_rewrite && !$wp_cache_mobile_enabled && strpos( $scrules, addcslashes( implode( '|', $wp_cache_mobile_browsers ), ' ' ) ) ) {
***************
*** 309,321 ****
--- 352,402 ----
  		}
  	}
  
+ 	if ( $valid_nonce && $_POST[ 'action' ] == 'dismiss_htaccess_warning' ) {
+ 		wp_cache_replace_line('^ *\$dismiss_htaccess_warning', "\$dismiss_htaccess_warning = 1;", $wp_cache_config_file);
+ 		$dismiss_htaccess_warning = 1;
+ 	} elseif ( !isset( $dismiss_htaccess_warning ) ) {
+ 		$dismiss_htaccess_warning = 0;
+ 	}
+ 	if ( $dismiss_htaccess_warning == 0 && $wp_cache_mod_rewrite && $super_cache_enabled && $disable_supercache_htaccess_warning == false && get_option( 'siteurl' ) != get_option( 'home' ) ) {
+ 		$home_dir = str_replace( get_option( 'home' ), '', get_option( 'siteurl' ) );
+ 		?><div id="message" class="updated fade"><h3><?php _e( '.htaccess file may need to be moved', 'wp-super-cache' ); ?></h3>
+ 		<p><?php _e( 'It appears you have WordPress installed in a sub directory as described <a href="http://codex.wordpress.org/Giving_WordPress_Its_Own_Directory">here</a>. Unfortunately WordPress writes to the .htaccess in the install directory, not where your site is served from.<br />When you update the rewrite rules in this plugin you will have to copy the file to where your site is hosted. This will be fixed in the future.', 'wp-super-cache' ); ?></p>
+ 		<form action="" method="POST">
+ 		<input type="hidden" name="action" value="dismiss_htaccess_warning" />
+ 		<input type="hidden" name="page" value="wpsupercache" />
+ 		<?php wp_nonce_field( 'wp-cache' ); ?>
+ 		<input type='submit' value='<?php _e( 'Dismiss', 'wp-super-cache' ); ?>' />
+ 		</form>
+ 		<br />	
+ 		</div><?php
+ 	}
+ 
  	return true;
  
  }
  add_filter( 'wp_super_cache_error_checking', 'wp_cache_manager_error_checks' );
  
+ function admin_bar_delete_page() {
+ 	// Delete cache for a specific page
+ 	if ( function_exists('current_user_can') && false == current_user_can('delete_others_posts') )
+ 		return false;
+ 	if ( isset( $_GET[ 'action' ] ) && $_GET[ 'action' ] == 'delcachepage' && ( isset( $_GET[ '_wpnonce' ] ) ? wp_verify_nonce( $_REQUEST[ '_wpnonce' ], 'delete-cache' ) : false ) ) {
+ 		$path = get_supercache_dir() . preg_replace( '/:.*$/', '', $_GET[ 'path' ] );
+ 		$files = get_all_supercache_filenames( $path );
+ 		foreach( $files as $cache_file )
+ 			prune_super_cache( $path . $cache_file, true ); 
+ 
+ 		wp_redirect( preg_replace( '/[ <>\'\"\r\n\t\(\)]/', '', $_GET[ 'path' ] ) );
+ 		die();
+ 	}
+ }
+ if ( isset( $_GET[ 'action' ] ) && $_GET[ 'action' ] == 'delcachepage' )
+    add_action( 'admin_init', 'admin_bar_delete_page' );
+ 
  function wp_cache_manager_updates() {
  	global $wp_cache_mobile_enabled, $wp_supercache_cache_list, $wp_cache_config_file, $wp_cache_hello_world, $wp_cache_clear_on_post_edit, $cache_rebuild_files, $wp_cache_mutex_disabled, $wp_cache_not_logged_in, $wp_cache_make_known_anon, $cache_path, $wp_cache_object_cache, $_wp_using_ext_object_cache, $wp_cache_refresh_single_only, $cache_compression, $wp_cache_mod_rewrite, $wp_supercache_304, $wp_super_cache_late_init, $wp_cache_front_page_checks, $cache_page_secret, $wp_cache_disable_utf8, $wp_cache_no_cache_for_get;
+ 	global $cache_schedule_type, $cache_scheduled_time, $cache_max_time, $cache_time_interval, $wp_cache_shutdown_gc;
  
  	if ( !wpsupercache_site_admin() )
  		return false;
***************
*** 325,341 ****
  		wp_cache_replace_line('^ *\$cache_page_secret', "\$cache_page_secret = '" . $cache_page_secret . "';", $wp_cache_config_file);
  	}
  
- 	// Delete cache for a specific page
- 	if ( isset( $_GET[ 'action' ] ) && $_GET[ 'action' ] == 'delete' && ( isset( $_GET[ '_wpnonce' ] ) ? wp_verify_nonce( $_REQUEST[ '_wpnonce' ], 'delete-cache' ) : false ) ) {
- 		$path = get_supercache_dir() . preg_replace( '/:.*$/', '', $_GET[ 'path' ] );
- 		$files = get_all_supercache_filenames( $path );
- 		foreach( $files as $cache_file )
- 			prune_super_cache( $path . $cache_file, true ); 
- 
- 		wp_redirect( preg_replace( '/[ <>\'\"\r\n\t\(\)]/', '', $_GET[ 'path' ] ) );
- 		die();
- 	}
- 
  	$valid_nonce = isset($_REQUEST['_wpnonce']) ? wp_verify_nonce($_REQUEST['_wpnonce'], 'wp-cache') : false;
  	if ( $valid_nonce == false )
  		return false;
--- 406,411 ----
***************
*** 348,356 ****
--- 418,443 ----
  			$_POST[ 'super_cache_enabled' ] = 2; // PHP
  			$_POST[ 'cache_rebuild_files' ] = 1;
  			unset( $_POST[ 'cache_compression' ] );
+ 			//
+ 			// set up garbage collection with some default settings
+ 			if ( ( !isset( $wp_cache_shutdown_gc ) || $wp_cache_shutdown_gc == 0 ) && false == wp_next_scheduled( 'wp_cache_gc' ) ) {
+ 				if ( false == isset( $cache_schedule_type ) ) {
+ 					$cache_schedule_type = 'interval';
+ 					$cache_time_interval = 600;
+ 					$cache_max_time = 1800;
+ 					wp_cache_replace_line('^ *\$cache_schedule_type', "\$cache_schedule_type = '$cache_schedule_type';", $wp_cache_config_file);
+ 					wp_cache_replace_line('^ *\$cache_time_interval', "\$cache_time_interval = '$cache_time_interval';", $wp_cache_config_file);
+ 					wp_cache_replace_line('^ *\$cache_max_time', "\$cache_max_time = '$cache_max_time';", $wp_cache_config_file);
+ 				}
+ 				wp_schedule_single_event( time() + 600, 'wp_cache_gc' );
+ 			}
+ 
  		} else {
  			unset( $_POST[ 'wp_cache_status' ] );
  			$_POST[ 'super_cache_enabled' ] = 0;
+ 			wp_clear_scheduled_hook( 'wp_cache_check_site_hook' );
+ 			wp_clear_scheduled_hook( 'wp_cache_gc' );
+ 			wp_clear_scheduled_hook( 'wp_cache_gc_watcher' );
  		}
  	}
  
***************
*** 398,404 ****
  		}
  		wp_cache_replace_line('^ *\$wp_cache_front_page_checks', "\$wp_cache_front_page_checks = " . $wp_cache_front_page_checks . ";", $wp_cache_config_file);
  
! 		$wp_supercache_cache_list = $_POST[ 'wp_supercache_cache_list' ] == 1 ? 1 : 0;
  		wp_cache_replace_line('^ *\$wp_supercache_cache_list', "\$wp_supercache_cache_list = " . $wp_supercache_cache_list . ";", $wp_cache_config_file);
  
  		if ( isset( $_POST[ 'wp_cache_status' ] ) ) {
--- 485,495 ----
  		}
  		wp_cache_replace_line('^ *\$wp_cache_front_page_checks', "\$wp_cache_front_page_checks = " . $wp_cache_front_page_checks . ";", $wp_cache_config_file);
  
! 		if( isset( $_POST[ 'wp_supercache_cache_list' ] ) ) {
! 			$wp_supercache_cache_list = 1;
! 		} else {
! 			$wp_supercache_cache_list = 0;
! 		}
  		wp_cache_replace_line('^ *\$wp_supercache_cache_list', "\$wp_supercache_cache_list = " . $wp_supercache_cache_list . ";", $wp_cache_config_file);
  
  		if ( isset( $_POST[ 'wp_cache_status' ] ) ) {
***************
*** 601,607 ****
  		$wp_cache_mod_rewrite = 1;
  	}
  
! 	if ( !isset( $_GET[ 'tab' ] ) && $cache_enabled && ( $wp_cache_mod_rewrite || $super_cache_enabled == false ) ) {
  		$_GET[ 'tab' ] = 'settings';
  		echo '<div id="message" class="updated fade"><p>' .  __( 'Notice: <em>Mod_rewrite or Legacy caching enabled</em>. Showing Advanced Settings Page by default.', 'wp-super-cache' ) . '</p></div>';
  	}
--- 692,701 ----
  		$wp_cache_mod_rewrite = 1;
  	}
  
! 	if ( !isset( $_GET[ 'tab' ] ) )
! 		$_GET[ 'tab' ] = '';
! 
! 	if ( $_GET[ 'tab' ] == '' && $cache_enabled && ( $wp_cache_mod_rewrite || $super_cache_enabled == false ) ) {
  		$_GET[ 'tab' ] = 'settings';
  		echo '<div id="message" class="updated fade"><p>' .  __( 'Notice: <em>Mod_rewrite or Legacy caching enabled</em>. Showing Advanced Settings Page by default.', 'wp-super-cache' ) . '</p></div>';
  	}
***************
*** 895,901 ****
  			<?php if ( $_wp_using_ext_object_cache ) { 
  				?><label><input type='checkbox' name='wp_cache_object_cache' <?php if( $wp_cache_object_cache ) echo "checked"; ?> value='1'> <?php echo __( 'Use object cache to store cached files.', 'wp-super-cache' ) . ' ' . __( '(Experimental)', 'wp-super-cache' ); ?></label><?php 
  			}?>
! 			<?php printf( __( '<strong>DO NOT CACHE PAGE</strong> secret key: <a href="%s">%s</a>', 'wp-super-cache' ), trailingslashit( get_bloginfo( 'wpurl' ) ) . "?donotcachepage={$cache_page_secret}", $cache_page_secret ); ?>
  				</legend>
  				</fieldset>
  			</td>
--- 989,995 ----
  			<?php if ( $_wp_using_ext_object_cache ) { 
  				?><label><input type='checkbox' name='wp_cache_object_cache' <?php if( $wp_cache_object_cache ) echo "checked"; ?> value='1'> <?php echo __( 'Use object cache to store cached files.', 'wp-super-cache' ) . ' ' . __( '(Experimental)', 'wp-super-cache' ); ?></label><?php 
  			}?>
! 			<?php printf( __( '<strong>DO NOT CACHE PAGE</strong> secret key: <a href="%s">%s</a>', 'wp-super-cache' ), trailingslashit( get_bloginfo( 'url' ) ) . "?donotcachepage={$cache_page_secret}", $cache_page_secret ); ?>
  				</legend>
  				</fieldset>
  			</td>
***************
*** 1035,1041 ****
  				}
  				echo '<form name="cache_tester" action="" method="post">';
  				echo '<input type="hidden" name="action" value="test" />';
! 				if ( 'on' == strtolower( $_SERVER['HTTPS' ] ) )
  					echo "<input type='checkbox' name='httponly' checked='checked' value='1' /> " . __( 'Send non-secure (non https) request for homepage', 'wp-super-cache' );
  				echo '<div class="submit"><input type="submit" name="test" value="' . __( 'Test Cache', 'wp-super-cache' ) . '" /></div>';
  				wp_nonce_field('wp-cache');
--- 1129,1135 ----
  				}
  				echo '<form name="cache_tester" action="" method="post">';
  				echo '<input type="hidden" name="action" value="test" />';
! 				if ( isset( $_SERVER['HTTPS' ] ) && 'on' == strtolower( $_SERVER['HTTPS' ] ) )
  					echo "<input type='checkbox' name='httponly' checked='checked' value='1' /> " . __( 'Send non-secure (non https) request for homepage', 'wp-super-cache' );
  				echo '<div class="submit"><input type="submit" name="test" value="' . __( 'Test Cache', 'wp-super-cache' ) . '" /></div>';
  				wp_nonce_field('wp-cache');
***************
*** 1077,1084 ****
  	</td><td valign='top' style='width: 300px'>
  	<div style='background: #ffc; border: 1px solid #333; margin: 2px; padding: 5px'>
  	<h3 align='center'><?php _e( 'Make WordPress Faster', 'wp-super-cache' ); ?></h3>
! 	<p><?php printf( __( '%1$s is maintained and developed by %2$s with contributions from many others.', 'wp-super-cache' ), '<a href="http://ocaoimh.ie/wp-super-cache/?r=supercache">WP Super Cache</a>', '<a href="http://ocaoimh.ie/?r=supercache">Donncha O Caoimh</a>' ); ?></p>
! 	<p><?php printf( __( 'He blogs at %1$s and posts photos at %2$s.', 'wp-super-cache' ), '<a href="http://ocaoimh.ie/?r=supercache">Holy Shmoly</a>', '<a href="http://inphotos.org/?r=supercache">In Photos.org</a>' ); ?></p>
  	<p><?php printf( __( 'Please say hi to him on %s too!', 'wp-super-cache' ), '<a href="http://twitter.com/donncha/">Twitter</a>' ); ?></p>
  	<h3 align='center'><?php _e( 'Need Help?', 'wp-super-cache' ); ?></h3>
  	<ol>
--- 1171,1178 ----
  	</td><td valign='top' style='width: 300px'>
  	<div style='background: #ffc; border: 1px solid #333; margin: 2px; padding: 5px'>
  	<h3 align='center'><?php _e( 'Make WordPress Faster', 'wp-super-cache' ); ?></h3>
! 	<p><?php printf( __( '%1$s is maintained and developed by %2$s with contributions from many others.', 'wp-super-cache' ), '<a href="http://ocaoimh.ie/y/34">WP Super Cache</a>', '<a href="http://ocaoimh.ie/y/35">Donncha O Caoimh</a>' ); ?></p>
! 	<p><?php printf( __( 'He blogs at %1$s and posts photos at %2$s.', 'wp-super-cache' ), '<a href="http://ocaoimh.ie/y/35">Holy Shmoly</a>', '<a href="http://ocaoimh.ie/y/2m">In Photos.org</a>' ); ?></p>
  	<p><?php printf( __( 'Please say hi to him on %s too!', 'wp-super-cache' ), '<a href="http://twitter.com/donncha/">Twitter</a>' ); ?></p>
  	<h3 align='center'><?php _e( 'Need Help?', 'wp-super-cache' ); ?></h3>
  	<ol>
***************
*** 1086,1091 ****
--- 1180,1186 ----
  	<li><?php printf( __( '<a href="%1$s">Installation Help</a>', 'wp-super-cache' ), 'http://wordpress.org/extend/plugins/wp-super-cache/installation/' ); ?></li>
  	<li><?php printf( __( '<a href="%1$s">Frequently Asked Questions</a>', 'wp-super-cache' ), 'http://wordpress.org/extend/plugins/wp-super-cache/faq/' ); ?></li>
  	<li><?php printf( __( '<a href="%1$s">Support Forum</a>', 'wp-super-cache' ), 'http://wordpress.org/tags/wp-super-cache' ); ?></li>
+ 	<li><?php printf( __( '<a href="%1$s">Development Version</a>', 'wp-super-cache' ), 'http://ocaoimh.ie/y/2o' ); ?></li>
  	</ol>
  	<h3 align='center'><?php _e( 'Rate This Plugin!', 'wp-super-cache' ); ?></h3>
  	<p><?php printf( __( 'Please <a href="%s">rate</a> this plugin and tell me if it works for you or not. It really helps development.', 'wp-super-cache' ), 'http://wordpress.org/extend/plugins/wp-super-cache/' ); ?></p>
***************
*** 1107,1118 ****
  		?></ol>
  		<small><?php _e( '(may not always be accurate on busy sites)', 'wp-super-cache' ); ?></small>
  		</p><?php 
! 	} else {
! 		$start_date = get_option( 'wpsupercache_start' );
! 		if ( $start_date ) {
! 			update_option( 'wpsupercache_start', $start_date );
  			update_option( 'wpsupercache_count', 0 );
- 		}
  	}
  	?>
  	</div>
--- 1202,1210 ----
  		?></ol>
  		<small><?php _e( '(may not always be accurate on busy sites)', 'wp-super-cache' ); ?></small>
  		</p><?php 
! 	} elseif ( false == get_option( 'wpsupercache_start' ) ) {
! 			update_option( 'wpsupercache_start', time() );
  			update_option( 'wpsupercache_count', 0 );
  	}
  	?>
  	</div>
***************
*** 1126,1131 ****
--- 1218,1224 ----
  function wpsc_plugins_tab() {
  	echo '<p>' . __( 'Cache plugins are PHP scripts that live in a plugins folder inside the wp-super-cache folder. They are loaded when Supercache loads, much sooner than regular WordPress plugins.', 'wp-super-cache' ) . '</p>';
  	echo '<p>' . __( 'This is strictly an advanced feature only and knowledge of both PHP and WordPress actions is required to create them.', 'wp-super-cache' ) . '</p>';
+ 	echo '<p>' . __( '<strong>Warning</strong>! Due to the way WordPress upgrades plugins the plugins you upload to wp-super-cache/plugins/ will be deleted when you upgrade WP Super Cache. You can avoid this by loading the plugins from elsewhere. Set <strong>$wp_cache_plugins_dir</strong> to the new location in wp-config.php and WP Super Cache will look there instead.<br />More info available in the <a href="http://ocaoimh.ie/wp-super-cache-developers/">developer documentation</a>.', 'wp-super-cache' ) . '</p>';
  	ob_start();
  	if( defined( 'WP_CACHE' ) ) {
  		if( function_exists( 'do_cacheaction' ) ) {
***************
*** 1179,1185 ****
  	if ( isset( $wpmu_version ) || function_exists( 'is_multisite' ) && is_multisite() ) {
  		if ( false == wpsupercache_site_admin() )
  			return false;
! 		if ( function_exists( "is_main_site" ) && false == is_main_site() || function_exists( 'is_main_blog' ) && false == is_main_blog() ) {
  			global $current_site;
  			$protocol = ( 'on' == strtolower( $_SERVER['HTTPS' ] ) ) ? 'https://' : 'http://';
  			if ( isset( $wpmu_version ) ) {
--- 1272,1278 ----
  	if ( isset( $wpmu_version ) || function_exists( 'is_multisite' ) && is_multisite() ) {
  		if ( false == wpsupercache_site_admin() )
  			return false;
! 		if ( function_exists( "is_main_site" ) && false == is_main_site() ) {
  			global $current_site;
  			$protocol = ( 'on' == strtolower( $_SERVER['HTTPS' ] ) ) ? 'https://' : 'http://';
  			if ( isset( $wpmu_version ) ) {
***************
*** 1192,1198 ****
  		}
  	}
  
! 	if ( function_exists( "is_main_site" ) && false == is_main_site() || function_exists( 'is_main_blog' ) && false == is_main_blog() )
  		return true;
  	?>
  	<a name="modrewrite"></a><fieldset class="options"> 
--- 1285,1291 ----
  		}
  	}
  
! 	if ( function_exists( "is_main_site" ) && false == is_main_site() )
  		return true;
  	?>
  	<a name="modrewrite"></a><fieldset class="options"> 
***************
*** 1479,1484 ****
--- 1572,1580 ----
  	if ( isset( $_POST['wp_max_time'] ) && $valid_nonce ) {
  		$cache_max_time = (int)$_POST['wp_max_time'];
  		wp_cache_replace_line('^ *\$cache_max_time', "\$cache_max_time = $cache_max_time;", $wp_cache_config_file);
+ 		// schedule gc watcher
+ 		if ( false == wp_next_scheduled( 'wp_cache_gc_watcher' ) )
+ 			wp_schedule_event( time()+600, 'hourly', 'wp_cache_gc_watcher' );
  	}
  
  	if ( isset( $_POST[ 'cache_gc_email_me' ] ) && $valid_nonce ) {
***************
*** 1488,1494 ****
  		$cache_gc_email_me = 0;
  		wp_cache_replace_line('^ *\$cache_gc_email_me', "\$cache_gc_email_me = $cache_gc_email_me;", $wp_cache_config_file); 
  	}
! 	if ( $_POST[ 'cache_schedule_type' ] == 'interval' && isset( $_POST['cache_time_interval'] ) && $valid_nonce ) {
  		wp_clear_scheduled_hook( 'wp_cache_gc' );
  		$cache_schedule_type = 'interval';
  		if ( (int)$_POST[ 'cache_time_interval' ] == 0 )
--- 1584,1590 ----
  		$cache_gc_email_me = 0;
  		wp_cache_replace_line('^ *\$cache_gc_email_me', "\$cache_gc_email_me = $cache_gc_email_me;", $wp_cache_config_file); 
  	}
! 	if ( isset( $_POST[ 'cache_schedule_type' ] ) && $_POST[ 'cache_schedule_type' ] == 'interval' && isset( $_POST['cache_time_interval'] ) && $valid_nonce ) {
  		wp_clear_scheduled_hook( 'wp_cache_gc' );
  		$cache_schedule_type = 'interval';
  		if ( (int)$_POST[ 'cache_time_interval' ] == 0 )
***************
*** 1506,1512 ****
  		$schedules = wp_get_schedules();
  		if ( isset( $schedules[ $_POST[ 'cache_schedule_interval' ] ] ) )
  			$cache_schedule_interval = $_POST[ 'cache_schedule_interval' ];
- 		wp_schedule_single_event( strtotime( $cache_scheduled_time ), 'wp_cache_gc' );
  		wp_cache_replace_line('^ *\$cache_schedule_type', "\$cache_schedule_type = '$cache_schedule_type';", $wp_cache_config_file);
  		wp_cache_replace_line('^ *\$cache_schedule_interval', "\$cache_schedule_interval = '{$cache_schedule_interval}';", $wp_cache_config_file);
  		wp_cache_replace_line('^ *\$cache_scheduled_time', "\$cache_scheduled_time = '$cache_scheduled_time';", $wp_cache_config_file);
--- 1602,1607 ----
***************
*** 1718,1726 ****
  }
  
  function wp_cache_debug_settings() {
! 	global $wp_super_cache_debug, $wp_cache_debug_log, $wp_cache_debug_ip, $cache_path, $valid_nonce, $wp_cache_config_file;
  	global $wp_super_cache_front_page_check, $wp_super_cache_front_page_clear, $wp_super_cache_front_page_text, $wp_super_cache_front_page_notification, $wp_super_cache_advanced_debug;
  
  	if ( isset( $_POST[ 'wp_cache_debug' ] ) && $valid_nonce ) {
  		$wp_super_cache_debug = intval( $_POST[ 'wp_super_cache_debug' ] );
  		wp_cache_replace_line('^ *\$wp_super_cache_debug', "\$wp_super_cache_debug = '$wp_super_cache_debug';", $wp_cache_config_file);
--- 1813,1823 ----
  }
  
  function wp_cache_debug_settings() {
! 	global $wp_super_cache_debug, $wp_cache_debug_log, $wp_cache_debug_ip, $cache_path, $valid_nonce, $wp_cache_config_file, $wp_super_cache_comments;
  	global $wp_super_cache_front_page_check, $wp_super_cache_front_page_clear, $wp_super_cache_front_page_text, $wp_super_cache_front_page_notification, $wp_super_cache_advanced_debug;
  
+ 	if ( false == isset( $wp_super_cache_comments ) )
+ 		$wp_super_cache_comments = 1;
  	if ( isset( $_POST[ 'wp_cache_debug' ] ) && $valid_nonce ) {
  		$wp_super_cache_debug = intval( $_POST[ 'wp_super_cache_debug' ] );
  		wp_cache_replace_line('^ *\$wp_super_cache_debug', "\$wp_super_cache_debug = '$wp_super_cache_debug';", $wp_cache_config_file);
***************
*** 1730,1735 ****
--- 1827,1834 ----
  			$wp_cache_debug_log = "";
  		}
  		wp_cache_replace_line('^ *\$wp_cache_debug_log', "\$wp_cache_debug_log = '$wp_cache_debug_log';", $wp_cache_config_file);
+ 		$wp_super_cache_comments = (int)$_POST[ 'wp_super_cache_comments' ];
+ 		wp_cache_replace_line('^ *\$wp_super_cache_comments', "\$wp_super_cache_comments = '$wp_super_cache_comments';", $wp_cache_config_file);
  		$wp_cache_debug_ip = esc_html( $_POST[ 'wp_cache_debug_ip' ] );
  		wp_cache_replace_line('^ *\$wp_cache_debug_ip', "\$wp_cache_debug_ip = '$wp_cache_debug_ip';", $wp_cache_config_file);
  		$wp_super_cache_front_page_check = (int)$_POST[ 'wp_super_cache_front_page_check' ];
***************
*** 1758,1763 ****
--- 1857,1867 ----
  	echo "<table class='form-table'>";
  	echo "<tr><td>" . __( 'Debugging', 'wp-super-cache' ) . "</td><td><input type='checkbox' name='wp_super_cache_debug' value='1' " . checked( 1, $wp_super_cache_debug, false ) . " /> " . __( 'enabled', 'wp-super-cache' ) . "</td></tr>";
  	echo "<tr><td>" . __( 'IP Address', 'wp-super-cache' ) . "</td><td> <input type='text' size='20' name='wp_cache_debug_ip' value='{$wp_cache_debug_ip}' /> " . sprintf( __( '(only log requests from this IP address. Your IP is %s)', 'wp-super-cache' ), $_SERVER[ 'REMOTE_ADDR' ] ) . "</td></tr>";
+ 	echo "<tr><td valign='top'>" . __( 'Cache Status Messages', 'wp-super-cache' ) . "</td><td><input type='checkbox' name='wp_super_cache_comments' value='1' " . checked( 1, $wp_super_cache_comments, false ) . " /> " . __( 'enabled', 'wp-super-cache' ) . "<br />";
+ 	echo  __( 'Display comments at the end of every page like this:', 'wp-super-cache' ) . "<br />";
+ 	echo "<pre>&lt;!-- Dynamic page generated in 0.450 seconds. -->
+ &lt;!-- Cached page generated by WP-Super-Cache on " . date( "Y-m-d H:i:s", time() ) . " -->
+ &lt;!-- super cache --></pre></td></tr>";
  	echo "</table>\n";
  	if ( isset( $wp_super_cache_advanced_debug ) ) {
  	echo "<h4>" . __( 'Advanced', 'wp-super-cache' ) . "</h4><p>" . __( 'In very rare cases two problems may arise on some blogs:<ol><li> The front page may start downloading as a zip file.</li><li> The wrong page is occasionally cached as the front page if your blog uses a static front page and the permalink structure is <em>/%category%/%postname%/</em>.</li></ol>', 'wp-super-cache' ) . '</p>';
***************
*** 1792,1797 ****
--- 1896,1904 ----
  function wp_cache_disable() {
  	global $wp_cache_config_file, $cache_enabled;
  
+ 	wp_clear_scheduled_hook( 'wp_cache_check_site_hook' );
+ 	wp_clear_scheduled_hook( 'wp_cache_gc' );
+ 	wp_clear_scheduled_hook( 'wp_cache_gc_watcher' );
  	if (wp_cache_replace_line('^ *\$cache_enabled', '$cache_enabled = false;', $wp_cache_config_file)) {
  		$cache_enabled = false;
  	}
***************
*** 1916,1921 ****
--- 2023,2029 ----
  
  function wp_cache_verify_config_file() {
  	global $wp_cache_config_file, $wp_cache_config_file_sample, $sem_id, $cache_path;
+ 	global $WPSC_HTTP_HOST;
  
  	$new = false;
  	$dir = dirname($wp_cache_config_file);
***************
*** 1950,1956 ****
  		$new = true;
  	}
  	if( $sem_id == 5419 && $cache_path != '' ) {
! 		$sem_id = crc32( $_SERVER[ 'SERVER_NAME' ] . $cache_path ) & 0x7fffffff;
  		wp_cache_replace_line('sem_id', '$sem_id = ' . $sem_id . ';', $wp_cache_config_file);
  	}
  	require($wp_cache_config_file);
--- 2058,2064 ----
  		$new = true;
  	}
  	if( $sem_id == 5419 && $cache_path != '' ) {
! 		$sem_id = crc32( $WPSC_HTTP_HOST . $cache_path ) & 0x7fffffff;
  		wp_cache_replace_line('sem_id', '$sem_id = ' . $sem_id . ';', $wp_cache_config_file);
  	}
  	require($wp_cache_config_file);
